//Direction.h

#ifndef DIRECTION_H
#define DIRECTION_H

#include <iostream>
#include <deque>
#include "Car.h"
#include "defs.h"

using std::deque;
using std::iterator;

class Direction
{
public:
	Direction();            //default constructor
	~Direction();           //destructor
	
	void setSignal(int s);  //sets the signal to the given int
	bool signalRed();       //return true if signal is red, false otherwise
	bool signalGreen();     //return true if signal is gree, false otherwise
	
	void setVPM(double);         //sets the cars per minute
	void doStuff();
	double getAverageWait();
	double getTrafficDensity();
	u_int getTotalThroughput();
	double getTotalAverageWait();
	
	void reset();

#if #debug(yes)
//debugging and testing funcions
	void show();
	void testAddCar(u_int t) { addCar(t); }
	bool testTestForCarArrival() { return testForCarArrival(); }
//end debugging and testing functions
#endif

private:
	deque<Car> carQ;          //the line of cars at the light
	int signal;               //the color of the signal, RED or GREEN
	double vpm;               //number of cars per minute
	u_int current_time;       //the current system time
	u_int total_throughput;   //the total throughput of this direction
	u_int current_throughput; //the throughput since last change
	u_int time_last_change;   //is the time that the light was last changed

	double total_avg_wait;    //the total average wait for all cars
	
	void addCar(u_int);          //create a new car with given arrival_time
	bool testForCarArrival();
};

#endif
