//CarDriver.cpp

#include <iostream>
#include <string>
#include "Direction.h"
#include "myStringFunctionsCPP.h"

using std::cout;
using std::cin;
using std::endl;


//------------------------------------------------------------------------------
void test_constructor()
{
	//test constructor
	cout <<"Testing constructor with no arguments." << endl;
	Direction a;
	cout <<"Dir a has";
	a.show();
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
void test_destructor()
{
	//test destructor
	Direction *b = new Direction();
	cout << "Testing destructor for direction b." << endl;
	delete b;
	cout << "b destroyed." << endl;
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
void test_setCPM()
{
	Direction a;

	//test setCPM
	cout <<"Testing setCPM." << endl;
	cout <<"Setting to 20." << endl;
	a.setCPM(20);
	cout <<"Dir a has"; a.show(); cout << endl;
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
void test_setSignal()
{
	Direction a;

	//test setSignal
	cout <<"Testing setSignal." << endl;
	cout <<"Testing RED." << endl;
	a.setSignal(RED);
	cout <<"Dir a has"; a.show(); cout << endl;
	cout <<"Testing GREEN."<< endl;
	a.setSignal(GREEN);
	cout <<"Dir a has"; a.show(); cout << endl;	
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
void test_signalRedGreen()
{
	Direction a;

	//test signalRED
	cout <<"Testing signalRed."<< endl;
	cout <<"Setting signal to RED"<< endl;
	a.setSignal(RED);
	cout <<"signalRed returned (" << a.signalRed() << ")" << endl;
	cout <<"Setting signal to GREEN"<< endl;
	a.setSignal(GREEN);
	cout <<"signalRed returned (" << a.signalRed() << ")" << endl;
	
	//test signalGREEN
	cout <<"Testing signalGreen."<< endl;
	cout <<"Setting signal to RED"<< endl;
	a.setSignal(RED);
	cout <<"signalGreen returned (" << a.signalGreen() << ")" << endl;
	cout <<"Setting signal to GREEN"<< endl;
	a.setSignal(GREEN);
	cout <<"signalGreen returned (" << a.signalGreen() << ")" << endl;
}
//------------------------------------------------------------------------------



//------------------------------------------------------------------------------
void test_addCar()
{
	Direction a;

	//test addCar
	cout << "Testing addCar function." <<endl;
	cout << "Adding car with time (10)." <<endl;
	a.testAddCar(10);
	cout <<"Dir a has"; a.show(); cout << endl;

	cout << "Adding car with time (20)." <<endl;
	a.testAddCar(20);
	cout << "Adding car with time (30)." <<endl;
	a.testAddCar(30);
	cout << "Adding car with time (40)." <<endl;
	a.testAddCar(40);
	cout <<"Dir a has"; a.show(); cout << endl;
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
void test_testForCarArrival()
{
	Direction a;
	int testAmount = 100000;
	int arrived = 0;
	srand(time(NULL));

	//test testForCarArrival
	cout << "Testing testForCarArrival" << endl;
	cout << "Setting cpm to 30" << endl;
	a.setCPM(30);
	//seed random number generator
	for (int i = 0; i < testAmount; ++i)
		if (a.testTestForCarArrival())	
			++arrived;
	cout << "Average CPM was (" << ((double) arrived / (double) testAmount) <<") ";
	cout << "expected (" << ((double) 30 / (double) 60) << ") ";
	cout << "error = (" << (((double) 30 / (double) 60) - ((double) arrived / (double) testAmount)) <<")" << endl;

	cout << endl;
	cout << "Setting cpm to 1" << endl;
	a.setCPM(1);
	//seed random number generator
	arrived = 0;
	for (int i = 0; i < testAmount; ++i)
		if (a.testTestForCarArrival())	
			++arrived;
	cout << "Average CPM was (" << ((double) arrived / (double) testAmount) <<") ";
	cout << "expected (" << ((double) 1 / (double) 60) << ") ";
	cout << "error = (" << (((double) 1 / (double) 60) - ((double) arrived / (double) testAmount)) <<")" << endl;

	cout << endl;
	cout << "Setting cpm to 0" << endl;
	a.setCPM(0);
	//seed random number generator
	arrived = 0;
	for (int i = 0; i < testAmount; ++i)
		if (a.testTestForCarArrival())	
			++arrived;
	cout << "Average CPM was (" << ((double) arrived / (double) testAmount) <<") ";
	cout << "expected (" << ((double) 0 / (double) 60) << ") ";
	cout << "error = (" << (((double) 0 / (double) 60) - ((double) arrived / (double) testAmount)) <<")" << endl;

	cout << endl;
	cout << "Setting cpm to 60" << endl;
	a.setCPM(60);
	//seed random number generator
	arrived = 0;
	for (int i = 0; i < testAmount; ++i)
		if (a.testTestForCarArrival())	
			++arrived;
	cout << "Average CPM was (" << ((double) arrived / (double) testAmount) <<") ";
	cout << "expected (" << ((double) 60 / (double) 60) << ") ";
	cout << "error = (" << (((double) 60 / (double) 60) - ((double) arrived / (double) testAmount)) <<")" << endl;

}
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
void test_getAverageWait()
{
	Direction a;

	cout << "Testing getAverageWait. " << endl;
	
	//test with no cars
	cout << "Testing with no cars. " << endl;
	cout << "getAverageWait returned (" <<a.getAverageWait() << ") expected (" << 0 << ")" << endl;
	
	//test with some cars with start time 300.
	cout << "Testing with 1 cars with start time 300. " << endl;
	cout << "Advancing time to 300." << endl;
	for (int i = 0; i < 300; ++i)
		a.doStuff();
	cout << "Adding cars at times 50" << endl;
	a.testAddCar(50);
	cout << "getAverageWait returned (" << a.getAverageWait() << ") expected (" << ((double)(300 - 50) / (double) 1) << ")" << endl;

	
	//test with some cars with start time 0.
	cout << "Testing with 5 cars with start time 300. " << endl;
	cout << "Adding cars at times 133, 200, 250, 300" << endl;
	a.testAddCar(133);
	a.testAddCar(200);
	a.testAddCar(250);
	a.testAddCar(300);
	cout << "getAverageWait returned (" << a.getAverageWait() << ") expected (" << ((double)((300*5) - (50+133+200+250+300))/ (double) 5) << ")" << endl;

}
//------------------------------------------------------------------------------



//------------------------------------------------------------------------------
void test_getTrafficDensity()
{
	Direction a;
	int numToAdd;
	int interval = 120;
	
	cout << "Testing getTrafficDensity. " << endl;
	
	//test with no density and green light
	a.setSignal(RED);
	a.doStuff();
	numToAdd = 0;
	a.setSignal(GREEN);
	for (int i = 0; i < interval; ++i)
	{
		if (i < (interval - (interval - numToAdd)))
			a.testAddCar(10);
		a.doStuff();
	}
	cout <<" getTrafficDensity returned (" << a.getTrafficDensity() << ")";
	cout <<" expected (" << ((double) numToAdd / ((double)interval / (double) 60)) << ")" << endl;
	
	
	//test with density of 1 per minute and green light
	a.setSignal(RED);
	a.doStuff();
	numToAdd = 2;
	a.setSignal(GREEN);
	for (int i = 0; i < interval; ++i)
	{
		if (i < (interval - (interval - numToAdd)))
			a.testAddCar(10);
		a.doStuff();
	}
	cout <<" getTrafficDensity returned (" << a.getTrafficDensity() << ")";
	cout <<" expected (" << ((double) numToAdd / ((double)interval / (double) 60)) << ")" << endl;
	
	//test with density of > 60 per minute and green light
	a.setSignal(RED);
	a.doStuff();
	numToAdd = 30;
	a.setSignal(GREEN);
	for (int i = 0; i < interval; ++i)
	{
		if (i < (interval - (interval - numToAdd)))
			a.testAddCar(10);
		a.testAddCar(10);
		a.doStuff();
	}
	cout <<" getTrafficDensity returned (" << a.getTrafficDensity() << ")";
	cout <<" expected (" << ((double) (numToAdd + interval) / ((double)interval / (double) 60)) << ")" << endl;
	
	//test with density of 30 per minute and green light
	a.setSignal(RED);
	a.doStuff();
	numToAdd = 60;
	a.setSignal(GREEN);
	for (int i = 0; i < interval; ++i)
	{
		if (i < (interval - (interval - numToAdd)))
			a.testAddCar(10);
		a.doStuff();
	}
	cout <<" getTrafficDensity returned (" << a.getTrafficDensity() << ")";
	cout <<" expected (" << ((double) numToAdd / ((double)interval / (double) 60)) << ")" << endl;
	
	//test with density of 60 per minute and green light
	a.setSignal(RED);
	a.doStuff();
	numToAdd = 120;
	a.setSignal(GREEN);
	for (int i = 0; i < interval; ++i)
	{
		if (i < (interval - (interval - numToAdd)))
			a.testAddCar(10);
		a.doStuff();
	}
	cout <<" getTrafficDensity returned (" << a.getTrafficDensity() << ")";
	cout <<" expected (" << ((double) numToAdd / ((double)interval / (double) 60)) << ")" << endl;
	
	//test with no density and red light first
	a.setSignal(RED);
	a.doStuff();
	numToAdd = 0;
	for (int i = 0; i < interval; ++i)
	{
		if (i < (interval - (interval - numToAdd)))
			a.testAddCar(10);
		a.doStuff();
	}
	a.setSignal(GREEN);
	for (int i = 0; i < interval; ++i)
		a.doStuff();

	cout <<" getTrafficDensity returned (" << a.getTrafficDensity() << ")";
	cout <<" expected (" << ((double) numToAdd / ((double)interval / (double) 60)) << ")" << endl;
	
	//test with density of 1 per minute and red light first
	a.setSignal(RED);
	a.doStuff();
	numToAdd = 2;
	for (int i = 0; i < interval; ++i)
	{
		if (i < (interval - (interval - numToAdd)))
			a.testAddCar(10);
		a.doStuff();
	}
	a.setSignal(GREEN);
	for (int i = 0; i < interval; ++i)
		a.doStuff();
	cout <<" getTrafficDensity returned (" << a.getTrafficDensity() << ")";
	cout <<" expected (" << ((double) numToAdd / ((double)interval / (double) 60)) << ")" << endl;
	
	//test with density of > 60 per minute and red light first
	a.setSignal(RED);
	a.doStuff();
	numToAdd = 30;
	for (int i = 0; i < interval; ++i)
	{
		if (i < (interval - (interval - numToAdd)))
			a.testAddCar(10);
		a.testAddCar(10);
		a.doStuff();
	}
	a.setSignal(GREEN);
	for (int i = 0; i < interval; ++i)
		a.doStuff();
	cout <<" getTrafficDensity returned (" << a.getTrafficDensity() << ")";
	cout <<" expected (" << ((double) (numToAdd + interval) / ((double)interval / (double) 60)) << ")" << endl;
	
	//test with density of 30 per minute and red light first
	a.setSignal(RED);
	a.doStuff();
	numToAdd = 60;
	for (int i = 0; i < interval; ++i)
	{
		if (i < (interval - (interval - numToAdd)))
			a.testAddCar(10);
		a.doStuff();
	}
	a.setSignal(GREEN);
	for (int i = 0; i < interval; ++i)
		a.doStuff();
	cout <<" getTrafficDensity returned (" << a.getTrafficDensity() << ")";
	cout <<" expected (" << ((double) numToAdd / ((double)interval / (double) 60)) << ")" << endl;
	
	//test with density of 60 per minute and red light first
	a.setSignal(RED);
	a.doStuff();
	numToAdd = 120;
	for (int i = 0; i < interval; ++i)
	{
		if (i < (interval - (interval - numToAdd)))
			a.testAddCar(10);
		a.doStuff();
	}
	a.setSignal(GREEN);
	for (int i = 0; i < interval; ++i)
		a.doStuff();
	cout <<" getTrafficDensity returned (" << a.getTrafficDensity() << ")";
	cout <<" expected (" << ((double) numToAdd / ((double)interval / (double) 60)) << ")" << endl;
}
//------------------------------------------------------------------------------



//------------------------------------------------------------------------------
void test_getTotalThroughput()
{
	Direction a;
	int numToAdd;
	
	cout << "Testing getTotalThroughput()" << endl;
	//test with no total throughput
	cout << "testing with no throughput. " << endl;
	cout << " getTotalThroughput returned (" << a.getTotalThroughput() << ")";
	cout << " expected (" << 0 << ")" << endl;
	cout << endl;
	
	//test with some total throughput after green light
	a = Direction();
	cout << "testing with some throughput and green light. " << endl;
	a.setSignal(GREEN);
	numToAdd = 30;
	for (int i = 0; i < numToAdd; ++i)
	{
		a.testAddCar(10);
		a.doStuff();
	}
	cout << " getTotalThroughput returned (" << a.getTotalThroughput() << ")";
	cout << " expected (" << numToAdd << ")" << endl;
	cout << endl;
	
	//test with some total throughput after red light then green
	a = Direction();
	cout << "testing with no some throughput and red light to green light. " << endl;
	a.setSignal(RED);
	numToAdd = 30;
	for (int i = 0; i < numToAdd; ++i)
	{
		a.testAddCar(10);
		a.doStuff();
	}
	a.setSignal(GREEN);
	a.doStuff();
	cout << " getTotalThroughput returned (" << a.getTotalThroughput() << ")";
	cout << " expected (" << numToAdd << ")" << endl;
	cout << endl;	
	
	//test with alot of total throughput after red and green light switching
	a = Direction();
	cout << "testing with alot of throughput with red and green intervals. " << endl;
	a.setSignal(RED);
	numToAdd = 7000;
	for (int i = 0; i < numToAdd; ++i)
	{
		if ((i % 50) == 0)
		{
			if (a.signalRed())
				a.setSignal(GREEN);
			else
				a.setSignal(RED);
		}	
		a.testAddCar(10);
		a.doStuff();
	}
	a.setSignal(GREEN);
	a.doStuff();
	cout << " getTotalThroughput returned (" << a.getTotalThroughput() << ")";
	cout << " expected (" << numToAdd << ")" << endl;
	cout << endl;	
}
//------------------------------------------------------------------------------



//------------------------------------------------------------------------------
void test_getTotalAverageWait()
{
	Direction a;

	cout << "Testing getTotalAverageWait. " << endl;
	
	//test with no cars
	cout << "Testing with no cars. " << endl;
	cout << "getTotalAverageWait returned (" << a.getTotalAverageWait() << ") expected (" << 0 << ")" << endl;
	
	cout << "Advancing time to 100" << endl;
	for (int i=0; i < 100; ++i)
		a.doStuff();
		
	cout << "Setting signal RED" << endl;
	a.setSignal(RED);
	
	cout << "Adding car at 100, 110, 120" << endl;
	a.testAddCar(100);
	for (int i=0; i < 10; ++i)
		a.doStuff();
	a.testAddCar(116);
	for (int i=0; i < 9; ++i)
		a.doStuff();
	a.testAddCar(120);
	
	cout << "getTotalAverageWait returned (" << a.getTotalAverageWait() << ")" << endl;
	cout << "Changing signal to green" << endl;
	a.setSignal(GREEN);
	a.doStuff();
	cout << "getTotalAverageWait returned (" << a.getTotalAverageWait() << ")" << endl;
	
}
//------------------------------------------------------------------------------


void clearScreen()
{
	system("cls"); // MS-DOS
}

int displayOptions()
{
	int x;
	//display options
	clearScreen();
	cout << "Please make a selection." << endl;
	cout << "-------------------------------------------" << endl;
	cout << " 0. exit"                                    << endl;
	cout << " 1. constructor"                             << endl;
	cout << " 2. destructor"                              << endl;
	cout << " 3. setCPM"                                  << endl;
	cout << " 4. setSignal"                               << endl;
	cout << " 5. signalRed / signalGreen"                 << endl;
	cout << " 6. addCar"                                  << endl;
	cout << " 7. testForCarArrival"                       << endl;
	cout << " 8. getAverageWait"                          << endl;
	cout << " 9. getTrafficDensity"                       << endl;
	cout << "10. getTotalThroughput"                      << endl;
	cout << "11. getTotalAverageWait"                     << endl;
	cout << "-------------------------------------------" << endl;
	
	//prompt for input
	cout << ">> ";
	while ( ((x = intPrompt()) == -9999) || (x < 0) || (x > 11) )
		cout << "that is an invalid selection. >> ";
	clearScreen();
	return(x);
}


int main()
{
	int loopDone;

	loopDone = 0;
	while (!loopDone)
	{
		cout << endl << "Press Enter to continue." << endl;
		anykey();
		switch (displayOptions()) //display options / get input
		{	//execute chosen test
		case  0: loopDone = 1;               break;
		case  1: test_constructor();         break;  
		case  2: test_destructor();          break;
		case  3: test_setCPM();              break;
		case  4: test_setSignal();           break;
		case  5: test_signalRedGreen();      break;
		case  6: test_addCar();              break;
		case  7: test_testForCarArrival();   break;
		case  8: test_getAverageWait();      break;
		case  9: test_getTrafficDensity();   break;
		case 10: test_getTotalThroughput();  break;
		case 11: test_getTotalAverageWait(); break;
		default: cout << "Invalid selection" << endl; 
		         anykey();                   break;
		}
	}

	return(0);
}



