//FLC_driver.cpp

#include <iostream>
#include <fstream>

#include "myStringFunctionsCPP.h"

#include "FuzzyLogicController.h"

using std::cout;
using std::cin;
using std::endl;
using std::ifstream;

typedef FuzzyLogicController<FuzzyInput_A, FuzzyInput_B, FuzzyOutput> fzFuzzyLogicController;

//------------------------------------------------------------------------------
void test_constructor()
{
	cout << "Testing default constructor" << endl;
	cout << "executing default constructor" <<endl;
	fzFuzzyLogicController flc;
	cout << "done." <<endl;
}
//------------------------------------------------------------------------------



//------------------------------------------------------------------------------
void test_destructor()
{
	fzFuzzyLogicController *flc = new fzFuzzyLogicController();
	cout << "Testing destructor" << endl;
	cout << "executing destructor" <<endl;
	delete flc;
	cout << "done." << endl;
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
void test_loadRuleBase()
{
	ifstream in("rulebase.txt");
	fzFuzzyLogicController flc;
	
	
	cout <<"Testing loadRuleBase" <<endl;
	cout <<"Executing loadRuleBase" << endl;
	flc.loadRuleBase(in);
	cout <<"done executing." <<endl;
	cout <<"RuleBase:" << endl;
	flc.showRuleBase();
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
void test_loadFuzzySets()
{
	ifstream in("fuzzysets.txt");
	fzFuzzyLogicController flc;
	
	
	cout <<"Testing loadFuzzySets" <<endl;
	cout <<"Executing loadFuzzySets" << endl;
	flc.loadFuzzySets(in);
	cout <<"done executing." <<endl;
	cout <<"Fuzzy Sets:" << endl;
	flc.showFuzzySets();
}
//------------------------------------------------------------------------------



//------------------------------------------------------------------------------
void test_compute()
{
	ifstream in1("fuzzysets.txt");
	ifstream in2("rulebase.txt");
	fzFuzzyLogicController flc;
	
	flc.loadFuzzySets(in1);
	flc.loadRuleBase(in2);
	cout <<"Testing compute" <<endl;
	cout <<"Testing with 10 10" << endl;
	cout <<"compute returned (" << flc.compute(10,10) << ")" << endl;

	cout <<"Testing with 60 60" <<endl;
	cout <<"compute returned (" << flc.compute(60,60) << ")" << endl;
}
//------------------------------------------------------------------------------



//------------------------------------------------------------------------------
void clearScreen()
{
	system("cls"); // MS-DOS
}

int displayOptions()
{
	int x;
	//display options
	clearScreen();
	cout << "Please make a selection." << endl;
	cout << "-------------------------------------------" << endl;
	//test choices go here
	cout << " 0. exit"                                    << endl;
	cout << " 1. test constructor"                        << endl;
	cout << " 2. test destructor"                         << endl;
	cout << " 3. test loadRuleBase"                       << endl;
	cout << " 4. test loadFuzzySets"                      << endl;
	cout << " 5. test compute"                            << endl;
	cout << "-------------------------------------------" << endl;

	//prompt for input
	cout << ">> ";
	while ( ((x = intPrompt()) == -9999) || (x < 0) || (x > 5) )
		cout << "that is an invalid selection. >> ";
	clearScreen();
	return(x);
}


int main()
{
	int loopDone;

	loopDone = 0;
	while (!loopDone)
	{
		cout << endl << "Press Enter to continue." << endl;
		anykey();
		switch (int n = displayOptions()) //display options / get input
		{	//execute chosen test
		case  0: loopDone = 1;            break;
		case  1: test_constructor();      break;
		case  2: test_destructor();       break;
		case  3: test_loadRuleBase();     break;
		case  4: test_loadFuzzySets();    break;
		case  5: test_compute();          break;
		default: cout << n << "Invalid selection" << endl;
		         anykey();                break;
		}
	}

	return(0);
}
