//RuleBase.cpp

#include "RuleBase.h"


template <class T1, class T2, class T3>
RuleBase<T1,T2,T3>::RuleBase()
{
}


template <class T1, class T2, class T3>
RuleBase<T1,T2,T3>::~RuleBase()
{
	base.clear();
}



template <class T1, class T2, class T3>
T3 RuleBase<T1,T2,T3>::getOutput(const Rule<T1,T2,T3> &r) const
{
	return (base.find(r)->second);
}



template <class T1, class T2, class T3>
void RuleBase<T1,T2,T3>::setRuleBase(std::istream &in)
{
	int count = FuzzyInput_A_Count * FuzzyInput_B_Count;
	T1 a;
	T2 b;
	T3 o;

	for (int i = 0; i < count; ++i)
	{
		in >> a;
		in >> b;
		in >> o;

		base[ Rule<T1,T2,T3>(a, b, 0.0, 0.0) ] = o;
	}
}


#if #debug(yes)
template <class T1, class T2, class T3>
void RuleBase<T1,T2,T3>::show()
{
	for (std::map<Rule<FuzzyInput_A, FuzzyInput_B, FuzzyOutput>, FuzzyOutput, comp_event>::iterator it = base.begin(); it != base.end(); ++it)
	{
		std::cout << " IF A is "  << std::setw(10) << (*it).first.A_set;
		std::cout << " AND B is " << std::setw(10) << (*it).first.B_set;
		std::cout << " THEN "     << std::setw(10) << (*it).second;
		std::cout << std::endl;
	}
}
#endif
