//RuleBase.h

#ifndef RULE_BASE_H
#define RULE_BASE_H

#include <map>
#include <iostream>
#include "Rule.h"

#if #debug(yes)
	#include <iostream>
	#include <iomanip>
#endif

//rule base map compare event
class comp_event
{
 public:
    bool operator()(const Rule<FuzzyInput_A, FuzzyInput_B, FuzzyOutput> &x,
                    const Rule<FuzzyInput_A, FuzzyInput_B, FuzzyOutput> &y) const
        { return (x < y); }
};


template<class T1, class T2, class T3>
class RuleBase
{
public:
	RuleBase();
	~RuleBase();
	
	T3 getOutput(const Rule<T1,T2,T3> &) const;
	void setRuleBase(std::istream &);
	
	friend class Rule<T1,T2,T3>;
	
#if #debug(yes)
	void show();
#endif

private:

	std::map<Rule<T1,T2,T3>, T3, comp_event> base;
};

template class RuleBase<FuzzyInput_A, FuzzyInput_B, FuzzyOutput>;

#endif
