
//Rule_driver.cpp

#include <iostream>
#include <fstream>
#include "myStringFunctionsCPP.h"

#include "RuleBase.h"
#include "Rule.h"
#include "FuzzySet.h"
#include "FuzzySetTypes.h"

using std::ifstream;
using std::cout;
using std::cin;
using std::endl;

typedef RuleBase<FuzzyInput_A, FuzzyInput_B, FuzzyOutput> fzRuleBase;
typedef Rule<FuzzyInput_A, FuzzyInput_B, FuzzyOutput>     fzRule;

//------------------------------------------------------------------------------
void test_constructor()
{
	cout << "Testing default constructor" << endl;
	cout << "executing default constructor" <<endl;
	fzRuleBase rb;
	rb.show();
}
//------------------------------------------------------------------------------



//------------------------------------------------------------------------------
void test_destructor()
{
	fzRuleBase *rb = new fzRuleBase();
	cout << "Testing destructor" << endl;
	cout << "executing destructor" <<endl;
	delete rb;
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
void test_getOutput()
{
	fzRuleBase rb;
	{
	fzRule r(VSHORT,VFEW,0,0);
	cout <<"Testing getOutput" << endl;
	cout <<"using rule with (short, very few, 0, 0)" <<endl;
	cout <<"getOutput returned (" << rb.getOutput(r) << ")" << endl;
	}
	{
	fzRule r(VLONG,VMANY,0,0);
	cout <<"using rule with (long, very many, 0, 0)" <<endl;
	cout <<"getOutput returned (" << rb.getOutput(r) << ")" << endl;
	}
}
//------------------------------------------------------------------------------



//------------------------------------------------------------------------------
void test_setRuleBase()
{
	cout <<"Testing setRuleBase" << endl;

	fzRuleBase rb;
	ifstream in("rulebase.txt");
	cout <<"Setting RuleBase" << endl;
	rb.setRuleBase(in);
	{
	fzRule r(VSHORT,VFEW,0,0);
	cout <<"using rule with (very short, very few, 0, 0)" <<endl;
	cout <<"getOutput returned (" << rb.getOutput(r) << ")" << endl;
	}
	{
	fzRule r(VLONG,VMANY,0,0);
	cout <<"using rule with (very long, very many, 0, 0)" <<endl;
	cout <<"getOutput returned (" << rb.getOutput(r) << ")" << endl;
	}
	cout << "press any key to dump rule base" << endl;
	anykey();
	rb.show();
}
//------------------------------------------------------------------------------



//------------------------------------------------------------------------------
void clearScreen()
{
	system("cls"); // MS-DOS
}

int displayOptions()
{
	int x;
	//display options
	clearScreen();
	cout << "Please make a selection." << endl;
	cout << "-------------------------------------------" << endl;
	//test choices go here
	cout << " 0. exit"                                    << endl;
	cout << " 1. test constructor"                        << endl;
	cout << " 2. test destructor"                         << endl;
	cout << " 3. test getOutput"                          << endl;
	cout << " 4. test setRuleBase"                        << endl;
	cout << "-------------------------------------------" << endl;

	//prompt for input
	cout << ">> ";
	while ( ((x = intPrompt()) == -9999) || (x < 0) || (x > 4) )
		cout << "that is an invalid selection. >> ";
	clearScreen();
	return(x);
}


int main()
{
	int loopDone;

	loopDone = 0;
	while (!loopDone)
	{
		cout << endl << "Press Enter to continue." << endl;
		anykey();
		switch (int n = displayOptions()) //display options / get input
		{	//execute chosen test
		case  0: loopDone = 1;            break;
		case  1: test_constructor();      break;
		case  2: test_destructor();       break;
		case  3: test_getOutput();        break;
		case  4: test_setRuleBase();      break;
		default: cout << n << "Invalid selection" << endl;
		         anykey();              break;
		}
	}

	return(0);
}
