//Rule.cpp

#include "Rule.h"


//assignment operator
template <class T1, class T2, class T3>
Rule<T1,T2,T3> &Rule<T1,T2,T3>::operator=(Rule<T1, T2, T3> &rhs)
{
	A_set = rhs.A_set;
	B_set = rhs.B_set;
	A_membership = rhs.A_membership;
	B_membership = rhs.B_membership;
	return rhs;
}


//less than comparison operator
template <class T1, class T2, class T3>
bool Rule<T1,T2,T3>::operator<(const Rule<T1, T2, T3> &rhs) const
{
	bool retval;

	//compare the first sets	
	if (A_set < rhs.A_set)
	{	//this set A is less
		retval = true;
	}//end if
	else if (A_set > rhs.A_set)
	{	//this set A is more
		retval = false;
	}//end else if
	else
	{	//the sets are equal
		//compare the second sets
		if (B_set < rhs.B_set)
		{	//this set B is less
			retval = true;
		}//end if
		else
		{	//this set A is more
			retval = false;
		}//end else
	}//end else
	
	return retval;
}

//return the output value of this rule		
template <class T1, class T2, class T3>
T3 Rule<T1,T2,T3>::getOutput()
{
	return (T3) 0;	
}

//return the fire strength of this rule
template <class T1, class T2, class T3>
double Rule<T1,T2,T3>::getFireStrength()
{
	double retval;
	
	if (A_membership < B_membership)
		retval = A_membership;
	else
		retval = B_membership;

	return retval;
}


#if #debug(yes)
template <class T1, class T2, class T3>
void Rule<T1,T2,T3>::show()
{
	std::cout << " A_set ("        << A_set        << ")";
	std::cout << " B_set ("        << B_set        << ")";
	std::cout << " A_membership (" << A_membership << ")";
	std::cout << " B_membership (" << B_membership << ")";	
}
#endif
