//Rule_driver.cpp

#include <iostream>
#include "myStringFunctionsCPP.h"

#include "Rule.h"

using std::cout;
using std::cin;
using std::endl;

typedef Rule<FuzzyInput_A, FuzzyInput_B, FuzzyOutput> fzRule;

//------------------------------------------------------------------------------
void test_constructor()
{
	cout << "Testing default constructor" << endl;
	cout << "executing default constructor" <<endl;
	fzRule r;
	r.show();
}
//------------------------------------------------------------------------------



//------------------------------------------------------------------------------
void test_constructor2()
{
	cout << "Testing constructor with arguments" << endl;
	cout << "executing constructor with arguments 1, 2, 3, 4" <<endl;
	fzRule r(MSHORT,SOME,3,4);
	r.show();
}
//------------------------------------------------------------------------------



//------------------------------------------------------------------------------
void test_copy_constructor()
{
	fzRule r1(MSHORT,SOME,3,4);
	cout << "Testing copy constructor" << endl;
	cout << "executing copy constructor with rule with:" <<endl;
	r1.show();
	fzRule r2(r1);
	cout << endl << "result:"<<endl;
	r2.show();
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
void test_destructor()
{
	fzRule *r = new fzRule();
	cout << "Testing destructor" << endl;
	cout << "executing destructor" <<endl;
	delete r;
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
void test_operatorEqual()
{
	fzRule r1(MSHORT,SOME,3,4);
	fzRule r2;
	cout << "Testing operator=" << endl;
	cout << "R1 has: " <<endl;
	r1.show();
	cout << endl;
	cout << "R2 has: " <<endl;
	r2.show();
	cout << endl;
	cout << "executing R1 = R2" <<endl;
	r2 = r1;
	r1.show();
	cout << endl;
	cout << "R2 has: " <<endl;
	r2.show();
	cout << endl;
	cout << endl;
	cout << "Testing after a change" << endl;
	fzRule r3(VLONG,VMANY,4,4);
	r1 = r3;
	r1.show();
	cout << endl;
	cout << "R2 has: " <<endl;
	r2.show();
	cout << endl;

}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
void test_operatorLessThan()
{
	cout << "Testing operator<" <<endl;
	//test with A1 < A2
	{
	fzRule r1(MSHORT,VFEW,0,0), r2(MEDIUM,VFEW,0,0);
	cout << "Rule 1: "; r1.show(); cout << endl;
	cout << "Rule 2: "; r2.show(); cout << endl;
	cout << "r1 < r2 returned (" << (r1 < r2) << ")" << endl;
	cout << endl;
	}
	//test with A1 > A2
	{
	fzRule r1(MLONG,VFEW,0,0), r2(MEDIUM,VFEW,0,0);
	cout << "Rule 1: "; r1.show(); cout << endl;
	cout << "Rule 2: "; r2.show(); cout << endl;
	cout << "r1 < r2 returned (" << (r1 < r2) << ")" << endl;
	cout << endl;
	}
	//test with A1 = A2 and B1 < B2
	{
	fzRule r1(MEDIUM,FEW,0,0), r2(MEDIUM,SOME,0,0);
	cout << "Rule 1: "; r1.show(); cout << endl;
	cout << "Rule 2: "; r2.show(); cout << endl;
	cout << "r1 < r2 returned (" << (r1 < r2) << ")" << endl;
	cout << endl;
	}
	//test with A1 = A2 and B1 > B2
	{
	fzRule r1(MEDIUM,MANY,0,0), r2(MEDIUM,SOME,0,0);
	cout << "Rule 1: "; r1.show(); cout << endl;
	cout << "Rule 2: "; r2.show(); cout << endl;
	cout << "r1 < r2 returned (" << (r1 < r2) << ")" << endl;
	cout << endl;
	}
	//test with A1 = A2 and B1 = B2
	{
	fzRule r1(MEDIUM,SOME,0,0), r2(MEDIUM,SOME,0,0);
	cout << "Rule 1: "; r1.show(); cout << endl;
	cout << "Rule 2: "; r2.show(); cout << endl;
	cout << "r1 < r2 returned (" << (r1 < r2) << ")" << endl;
	cout << endl;
	}
}
//------------------------------------------------------------------------------



//------------------------------------------------------------------------------
void clearScreen()
{
	system("cls"); // MS-DOS
}

int displayOptions()
{
	int x;
	//display options
	clearScreen();
	cout << "Please make a selection." << endl;
	cout << "-------------------------------------------" << endl;
	//test choices go here
	cout << " 0. exit"                                    << endl;
	cout << " 1. test constructor"                        << endl;
	cout << " 2. test constructor with arguments"         << endl;
	cout << " 3. test copy constructor"                   << endl;
	cout << " 4. test destructor"                         << endl;
	cout << " 5. test operator="                          << endl;
	cout << " 6. test operator<"                          << endl;
	cout << "-------------------------------------------" << endl;

	//prompt for input
	cout << ">> ";
	while ( ((x = intPrompt()) == -9999) || (x < 0) || (x > 6) )
		cout << "that is an invalid selection. >> ";
	clearScreen();
	return(x);
}


int main()
{
	int loopDone;

	loopDone = 0;
	while (!loopDone)
	{
		cout << endl << "Press Enter to continue." << endl;
		anykey();
		switch (int n = displayOptions()) //display options / get input
		{	//execute chosen test
		case  0: loopDone = 1;            break;
		case  1: test_constructor();      break;
		case  2: test_constructor2();     break;
		case  3: test_copy_constructor(); break;
		case  4: test_destructor();       break;
		case  5: test_operatorEqual();    break;
		case  6: test_operatorLessThan(); break;
		default: cout << n << "Invalid selection" << endl;
		         anykey();              break;
		}
	}

	return(0);
}
