//RuleBase.h

#ifndef RULE_BASE_H
#define RULE_BASE_H

#include <map>
#include <iostream>
#include "Rule.h"

#if #debug(yes)
	#include <iostream>
	#include <iomanip>
#endif

//rule base map compare event
class comp_event
{
 public:
    bool operator()(const Rule &x, const Rule &y) const
        { return (x < y); }
};


class RuleBase
{
public:
	RuleBase();
	~RuleBase();
	
	int getOutput(const Rule &) const;
	void setRuleBase(std::istream &);
	
	friend class Rule;
	
#if #debug(yes)
	void show();
#endif

private:
	void initRuleBase();

	std::map<Rule, int, comp_event> base;
};

#endif
