//.cpp

#include <iostream>
#include <fstream>
#include <time.h>
#include <string>
#include <vector>

#include "IntersectionSimulator.h"

using std::ifstream;
using std::cout;
using std::cin;
using std::endl;
using std::cerr;
using std::string;
using std::vector;
using std::iterator;

int main(int argc, char *args[])
{
	//simulates 100 trials, fuzzy logic vs timer
	//	100000 time limit
	//		fixed values 0 to 60 for d1
	//		fixed values 0 to 60 for d2
	//	flc
	//	timer at 60 seconds

	//string s1(args[1]);
	//string s2(args[2]);
	
	ifstream in_1(args[1]);
	ifstream in_2(args[2]);
	
	unsigned long seed = time(NULL);
	
	int trial_count    = 100;
	int time_limit     = 1000;
	int timer_interval = 30;

	int vpm_low1  = 0;
	int vpm_low2  = 0;
	int vpm_high1 = 60;
	int vpm_high2 = 60;
	
	int rule_count;

	double x;
	vector<double> fuzzy_set_data;
	vector<double> rule_base_data;
	

	in_1 >> x;
	while (!in_1.eof())
	{
		fuzzy_set_data.push_back(x);
		in_1 >> x;
	}
	in_1.close();

	in_2 >> rule_count;
	for (int j = 0; j < (rule_count * 3); ++j)
	{
		in_2 >> x;
		rule_base_data.push_back(x);
	}
	in_2.close();
	
	
	cout << trial_count << endl;
	
//	for (int i = 0; i < trial_count; ++i)
//		for (int vpm1 = vpm_low1; vpm1 < vpm_high1; ++vpm1)
//		for (int vpm2 = vpm_low2; vpm2 < vpm_high2; ++vpm2)
//		{
			int vpm1 = 30;
			int vpm2 = 30;
			int i = 0;
			
			cout << time_limit       << endl;
			cout << (seed + i)       << endl;
			cout << FUZZY_LOGIC_TYPE << endl;

			for (vector<double>::iterator it = fuzzy_set_data.begin(); it < fuzzy_set_data.end(); ++it)
				cout << (*it) << endl;

			cout << rule_count << endl;
			for (vector<double>::iterator it = rule_base_data.begin(); it < rule_base_data.end(); ++it)
				cout << (*it) << endl;
				
			cout << VPM_FIXED << endl;
			cout << vpm1      << endl;
			cout << vpm2      << endl;
			

			cout << time_limit     << endl;
			cout << seed + i       << endl;
			cout << TIMER_TYPE     << endl;
			cout << timer_interval << endl;

			cout << VPM_FIXED << endl;
			cout << vpm1      << endl;
			cout << vpm2      << endl;
//		}

	return 0;
}

