//FuzzyLogicController.h

#ifndef FLC_H
#define FLC_H

#include <vector>
#include <iostream>
#include "FuzzySet.h"
#include "Rule.h"
#include "RuleBase.h"

using std::vector;

template <class T1, class T2, class T3>
class FuzzyLogicController
{
public:
	FuzzyLogicController();
	~FuzzyLogicController();

	void loadFuzzySets(std::istream &);
	void loadRuleBase(std::istream &);
	T3 compute(double, double);
	
#if #debug(yes)
	void showRuleBase();
	void showFuzzySets();
#endif

private:
	RuleBase<T1,T2,T3> rb;
	vector<FuzzySet<T1> > A_sets;
	vector<FuzzySet<T2> > B_sets;
};

template class FuzzyLogicController<FuzzyInput_A, FuzzyInput_B, FuzzyOutput>;

#endif
