//FuzzySet.h

#ifndef FUZZY_SET_H
#define FUZZY_SET_H

#include "FuzzySetTypes.h"

//DUBUGGING STUFF
#if #debug(yes)
	#include <iostream>
	#include <iomanip>
#endif
//END DUBUGGING STUFF

template<class T>
class FuzzySet
{
public:
	FuzzySet(T i, double s, double e, double p) : id(i), start(s), end(e), peak(p) {}
	FuzzySet(const FuzzySet &rhs) : id(rhs.id), start(rhs.start), end(rhs.end), peak(rhs.peak) {}
	~FuzzySet() {}

	double getMembership(double);
	T getId();

//DUBUGGING STUFF
#if #debug(yes)
	void show();
#endif
//END DUBUGGING STUFF

protected:
	T id;
	double start, end, peak;
};

template class FuzzySet<FuzzyInput_A>;
template class FuzzySet<FuzzyInput_B>;
template class FuzzySet<FuzzyOutput>;

#endif
