//FuzzyInputTypes.cpp

#include "FuzzySetTypes.h"

std::ostream& operator<<(std::ostream& os, FuzzyInput_A e)
{
	char* s;
	switch (e)
	{
	case VSHORT:
		s = "very_short";
		break;
	case MSHORT:
		s = "short";
		break;
	case MEDIUM:
		s = "medium";
		break;
	case MLONG:
		s = "long";
		break;
	case VLONG:
		s = "very_long";
		break;
	default:
		s = "ERROR (default value for FuzzyInput_A reached.";
		break;
	}
	return os << s;
}


std::ostream& operator<<(std::ostream& os, FuzzyInput_B e)
{
	char* s;
	switch (e)
	{
	case VFEW:
		s = "very_few";
		break;
	case FEW:
		s = "few";
		break;
	case SOME:
		s = "some";
		break;
	case MANY:
		s = "many";
		break;
	case VMANY:
		s = "very_many";
		break;
	default:
		s = "ERROR (default value for FuzzyInput_B reached.";
		break;
	}
	return os << s;
}


std::ostream& operator<<(std::ostream& os, FuzzyOutput e)
{
	char* s;
	switch (e)
	{
	case NOCHANGE:
		s = "no_change";
		break;
	case CHANGE:
		s = "change";
		break;
	default:
		s = "ERROR (default value for FuzzyOutput reached.";
		break;
	}
	return os << s;
}











std::istream& operator>>(std::istream& is, FuzzyInput_A &e)
{
	std::string s;
	is >> s;
	
	if      ("very_short" == s)
		e = VSHORT;
	else if ("short"      == s)
		e = MSHORT;
	else if ("medium"     == s)
		e = MEDIUM;
	else if ("long"       == s)
		e = MLONG;
	else if ("very_long"  == s)
		e = VLONG;
	else 
		e = (FuzzyInput_A) 0;
		
	return is;
}


std::istream& operator>>(std::istream& is, FuzzyInput_B &e)
{
	std::string s;
	is >> s;

	if      ("very_few"  == s)
		e = VFEW;
	else if ("few"       == s)
		e = FEW;
	else if ("some"      == s)
		e = SOME;
	else if ("many"      == s)
		e = MANY;
	else if ("very_many" == s)
		e = VMANY;
	else
		e = (FuzzyInput_B) 0;

	return is;
}


std::istream& operator>>(std::istream& is, FuzzyOutput &e)
{
	std::string s;
	is >> s;

	if      ("no_change" == s)
		e = NOCHANGE;
	else if ("change"    == s)
		e = CHANGE;
	else
		e = (FuzzyOutput) 0;

	return is;
}
