//FuzzySet_driver.cpp

#include <iostream>
#include "myStringFunctionsCPP.h"

#include "FuzzySet.h"

using std::cout;
using std::cin;
using std::endl;




//------------------------------------------------------------------------------
void test_constructor()
{
	cout << "Testing constructor" << endl;
	cout << "executing constructor with arguments 1, 2, 3, 4" <<endl;
	FuzzySet<FuzzyInput_A> f(MSHORT,2,3,4);
	f.show();
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
void test_copy_constructor()
{
	FuzzySet<FuzzyInput_A> f(MSHORT,2,3,4);
	cout << "Testing copy constructor" << endl;
	cout << "executing copy constructor with fuzzy set with:" <<endl;
	f.show();
	FuzzySet<FuzzyInput_A> e(f);
	cout << endl << "result:"<<endl;
	e.show();
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
void test_destructor()
{
	FuzzySet<FuzzyInput_A> *f = new FuzzySet<FuzzyInput_A>(MSHORT,2,3,4);
	cout << "Testing destructor" << endl;
	cout << "executing destructor" <<endl;
	delete f;
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
void test_getId()
{
	FuzzySet<FuzzyInput_A> f(MSHORT,2,3,4);
	cout << "Testing getId" << endl;
	cout << "getId returned (" << f.getId() << ")" <<endl;
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
void test_getMembership()
{
	double s, e, p, v;
	s = 2;
	e = 8;
	p = 5;
	FuzzySet<FuzzyInput_A> f(MSHORT, s, e, p);

	cout << "Testing getMembership" << endl;
	//test with a middle full triangle
	//test with v > end
	cout << "Testing with v > end" << endl;
	v = e+1;
	cout << "getMembership(" << v << ") returned (" << f.getMembership(v) << ")" << endl;
	//test with v = end
	cout << "Testing with v = end" << endl;
	v = e;
	cout << "getMembership(" << v << ") returned (" << f.getMembership(v) << ")" << endl;
	//test with v < start
	cout << "Testing with v < start" << endl;
	v = s-1;
	cout << "getMembership(" << v << ") returned (" << f.getMembership(v) << ")" << endl;
	//test with v = start
	cout << "Testing with v = start" << endl;
	v = s;
	cout << "getMembership(" << v << ") returned (" << f.getMembership(v) << ")" << endl;
	//test with v = peak
	cout << "Testing with v = peak" << endl;
	v = p;
	cout << "getMembership(" << v << ") returned (" << f.getMembership(v) << ")" << endl;
	//test with v 1/2 between start and peak
	cout << "Testing with v 1/2 between start and peak" << endl;
	v = s + ((p-s) / 2);
	cout << "getMembership(" << v << ") returned (" << f.getMembership(v) << ")" << endl;
	//test with v 1/4 between start and peak
	cout << "Testing with v 1/4 between start and peak" << endl;
	v = s + ((p-s) / 4);
	cout << "getMembership(" << v << ") returned (" << f.getMembership(v) << ")" << endl;
	//test with v 1/2 between peak and end
	cout << "Testing with v 1/2 between peak and end" << endl;
	v = e - ((e-p) / 2);
	cout << "getMembership(" << v << ") returned (" << f.getMembership(v) << ")" << endl;
	//test with v 1/4 between peak and end
	cout << "Testing with v 1/4 between peak and end" << endl;
	v = e - ((e-p) / 4);
	cout << "getMembership(" << v << ") returned (" << f.getMembership(v) << ")" << endl;


	anykey();
	//test with a half triangle
	//test with v > end
	s = 5;
	p = 8;
	e = 8;
	FuzzySet<FuzzyInput_A> h(VSHORT, s, e, p);
	cout << "Testing with v > end" << endl;
	v = e+1;
	cout << "getMembership(" << v << ") returned (" << h.getMembership(v) << ")" << endl;
	//test with v = end
	cout << "Testing with v = end" << endl;
	v = e;
	cout << "getMembership(" << v << ") returned (" << h.getMembership(v) << ")" << endl;
	//test with v < start
	cout << "Testing with v < start" << endl;
	v = s-1;
	cout << "getMembership(" << v << ") returned (" << h.getMembership(v) << ")" << endl;
	//test with v = start
	cout << "Testing with v = start" << endl;
	v = s;
	cout << "getMembership(" << v << ") returned (" << h.getMembership(v) << ")" << endl;
	//test with v = peak
	cout << "Testing with v = peak" << endl;
	v = p;
	cout << "getMembership(" << v << ") returned (" << h.getMembership(v) << ")" << endl;
	//test with v 1/2 between start and peak
	cout << "Testing with v 1/2 between start and peak" << endl;
	v = s + ((p-s) / 2);
	cout << "getMembership(" << v << ") returned (" << h.getMembership(v) << ")" << endl;
	//test with v 1/4 between start and peak
	cout << "Testing with v 1/4 between start and peak" << endl;
	v = s + ((p-s) / 4);
	cout << "getMembership(" << v << ") returned (" << h.getMembership(v) << ")" << endl;
	//test with v 1/2 between peak and end
	cout << "Testing with v 1/2 between peak and end" << endl;
	v = e - ((e-p) / 2);
	cout << "getMembership(" << v << ") returned (" << h.getMembership(v) << ")" << endl;
	//test with v 1/4 between peak and end
	cout << "Testing with v 1/4 between peak and end" << endl;
	v = e - ((e-p) / 4);
	cout << "getMembership(" << v << ") returned (" << h.getMembership(v) << ")" << endl;


	anykey();
	//test with a half triangle
	//test with v > end
	s = 5;
	p = 5;
	e = 8;
	FuzzySet<FuzzyInput_A> g(VSHORT, s, e, p);
	cout << "Testing with v > end" << endl;
	v = e+1;
	cout << "getMembership(" << v << ") returned (" << g.getMembership(v) << ")" << endl;
	//test with v = end
	cout << "Testing with v = end" << endl;
	v = e;
	cout << "getMembership(" << v << ") returned (" << g.getMembership(v) << ")" << endl;
	//test with v < start
	cout << "Testing with v < start" << endl;
	v = s-1;
	cout << "getMembership(" << v << ") returned (" << g.getMembership(v) << ")" << endl;
	//test with v = start
	cout << "Testing with v = start" << endl;
	v = s;
	cout << "getMembership(" << v << ") returned (" << g.getMembership(v) << ")" << endl;
	//test with v = peak
	cout << "Testing with v = peak" << endl;
	v = p;
	cout << "getMembership(" << v << ") returned (" << g.getMembership(v) << ")" << endl;
	//test with v 1/2 between start and peak
	cout << "Testing with v 1/2 between start and peak" << endl;
	v = s + ((p-s) / 2);
	cout << "getMembership(" << v << ") returned (" << g.getMembership(v) << ")" << endl;
	//test with v 1/4 between start and peak
	cout << "Testing with v 1/4 between start and peak" << endl;
	v = s + ((p-s) / 4);
	cout << "getMembership(" << v << ") returned (" << g.getMembership(v) << ")" << endl;
	//test with v 1/2 between peak and end
	cout << "Testing with v 1/2 between peak and end" << endl;
	v = e - ((e-p) / 2);
	cout << "getMembership(" << v << ") returned (" << g.getMembership(v) << ")" << endl;
	//test with v 1/4 between peak and end
	cout << "Testing with v 1/4 between peak and end" << endl;
	v = e - ((e-p) / 4);
	cout << "getMembership(" << v << ") returned (" << g.getMembership(v) << ")" << endl;

}
//------------------------------------------------------------------------------




//------------------------------------------------------------------------------
void clearScreen()
{
	system("cls"); // MS-DOS
}

int displayOptions()
{
	int x;
	//display options
	clearScreen();
	cout << "Please make a selection." << endl;
	cout << "-------------------------------------------" << endl;
	//test choices go here
	cout << " 0. exit"                                    << endl;
	cout << " 1. test constructor"                        << endl;
	cout << " 2. test copy constructor"                   << endl;
	cout << " 3. test destructor"                         << endl;
	cout << " 4. test getId"                              << endl;
	cout << " 5. test getMembership"                      << endl;
	cout << "-------------------------------------------" << endl;

	//prompt for input
	cout << ">> ";
	while ( ((x = intPrompt()) == -9999) || (x < 0) || (x > 5) )
		cout << "that is an invalid selection. >> ";
	clearScreen();
	return(x);
}


int main()
{
	int loopDone;

	loopDone = 0;
	while (!loopDone)
	{
		cout << endl << "Press Enter to continue." << endl;
		anykey();
		switch (int n = displayOptions()) //display options / get input
		{	//execute chosen test
		case  0: loopDone = 1;            break;
		case  1: test_constructor();      break;
		case  2: test_copy_constructor(); break;
		case  3: test_destructor();       break;
		case  4: test_getId();            break;
		case  5: test_getMembership();    break;
		default: cout << n << "Invalid selection" << endl;
		         anykey();              break;
		}
	}

	return(0);
}
