//FuzzySet.cpp

#include "FuzzySet.h"


//return the membership value
template <class T>
double FuzzySet<T>::getMembership(double v)
{
	double retval = 0;

	//test if the value is equal to or past the end value
	if (v >= end)
		//test if the end is also the peak
		if (end == peak)
			retval = 1;
		else
			retval = 0;
	//test if the value is equal to or before the start
	else if (v <= start)
		//test if the start is also the peak
		if (start == peak)
			retval = 1;
		else
			retval = 0;
	//test if the value is less than the peak
	else if (v < peak)
		retval = ((v - start) / (peak - start));
	//test if the value is greater than the peak
	else if (v > peak)
		retval = ((end - v) / (end - peak));
	//test if the value is the peak
	else if (v == peak)
		retval = 1;

	return retval;
}


//returns the fuzzy set id
template <class T>
T FuzzySet<T>::getId()
{
	return id;
}

//DEBUGGING STUFF
#if #debug(yes)
template <class T>
void FuzzySet<T>::show()
{
	std::cout <<" id ("    << id    << ")";
	std::cout <<" start (" << start << ")";
	std::cout <<" end ("   << end   << ")";
	std::cout <<" peak ("  << peak  << ")";
}
#endif
