//FuzzyLogicController.h

#ifndef FLC_H
#define FLC_H

#include <vector>
#include <iostream>
#include "FuzzySet.h"
#include "Rule.h"
#include "RuleBase.h"
#include "defs.h"

#define CHANGE   1
#define NOCHANGE 0


using std::vector;

class FuzzyLogicController
{
public:
	FuzzyLogicController();
	~FuzzyLogicController();

	void loadFuzzySets(std::istream &);
	void loadRuleBase(std::istream &);
	int compute(double, double);

private:
	RuleBase rb;
	vector<FuzzySet> A_sets;
	vector<FuzzySet> B_sets;
};

#endif
