//FuzzySet.h

#ifndef FUZZY_SET_H
#define FUZZY_SET_H


//DUBUGGING STUFF
#if #debug(yes)
	#include <iostream>
#endif
//END DUBUGGING STUFF

enum { NOCHANGE, CHANGE };
enum FuzzySet_id { PB, PS, Z, NS, NB };

class FuzzySet
{
public:
	FuzzySet(FuzzySet_id i, double s, double e, double p) : id(i), start(s), end(e), peak(p) {}
	FuzzySet(const FuzzySet &rhs) : id(rhs.id), start(rhs.start), end(rhs.end), peak(rhs.peak) {}
	~FuzzySet() {}

	double getMembership(double);
	FuzzySet_id getId();

//DUBUGGING STUFF
#if #debug(yes)
	void show();
#endif
//END DUBUGGING STUFF

protected:
	FuzzySet_id id;
	double start, end, peak;
};

#endif
